/*=============================================================================
// File Name:   W25Qxx.h
// Author:      Wood Wang
// Date:        2020/03/14
// Version:     v1.0

=============================================================================*/


#ifndef _W25QXX__H_
#define _W25QXX__H_

#include "Headfile.h"

//W25QXX
#define W25Q80 		0XEF13 	
#define W25Q16 		0XEF14
#define W25Q32 		0XEF15
#define W25Q64 		0XEF16
#define W25Q128 	0XEF17
				 
////////////////////////////////////////////////////////////////////////////
 
//ָ
#define W25X_WriteEnable		0x06 
#define W25X_WriteDisable		0x04 
#define W25X_ReadStatusReg		0x05 
#define W25X_WriteStatusReg		0x01 
#define W25X_ReadData			0x03 
#define W25X_FastReadData		0x0B 
#define W25X_FastReadDual		0x3B 
#define W25X_PageProgram		0x02 
#define W25X_BlockErase			0xD8 
#define W25X_SectorErase		0x20 
#define W25X_ChipErase			0xC7 
#define W25X_PowerDown			0xB9 
#define W25X_ReleasePowerDown	0xAB 
#define W25X_DeviceID			0xAB 
#define W25X_ManufactDeviceID	0x90 
#define W25X_JedecDeviceID		0x9F 


extern uint8_t W25QXX_Init(void);

uint16_t W25QXX_ReadID(void);
uint8_t W25QXX_ReadSR(void) ;
void W25QXX_WriteSR(uint8_t sr);
void W25QXX_WriteEnable(uint8_t Enable) ;

void W25QXX_PowerDown(void) ;
void W25QXX_WAKEUP(void)  ;

void W25QXX_EraseChip(void) ;
void W25QXX_EraseBlock(uint32_t Addr) ;
void W25QXX_EraseSector(uint32_t Addr);


void W25QXX_Read(uint32_t Addr,uint8_t* pBuffer,uint32_t Len);
void W25QXX_WritePage(uint32_t Addr,uint8_t* pBuffer,uint32_t Len);
void W25QXX_Write_NoCheck(uint32_t Addr,uint8_t* pBuffer,uint32_t Len);
void W25QXX_Write(uint32_t Addr,uint8_t* pBuffer,uint32_t Len);


#endif // _W25QXX__H_

